<template>
  <PageContainer>
    <template slot="header">
      <MControlPanel
        :state="pageState"
        :can-create="canCreate"
        :can-update="canUpdate"
        @on-state-button-clicked="onStateButtonClicked()"
        @on-action-button-clicked="onActionButtonClicked()"
        :actions="actions"
      >
      </MControlPanel>
    </template>

    <template slot="content" style="background-color: white">

      <div class="col-12 q-pb-xs q-pt-xs q-pl-md  q-mt-xs q-mb-xs">
        <ValidationObserver v-slot="{ handleSubmit }">
          <q-form ref="FormSubmit" @submit="handleSubmit(onSubmit)">
            <q-card bordered flat square class="no-padding">
              <q-card-section :horizontal="$q.screen.xl||$q.screen.lg||$q.screen.md">
                <div class="col-xs-12 col-sm-12 col-md-5 col-lg-3 q-pa-lg text-center">
                  <avatar-card  class="inline-block" :mode="pageState" :loading="isAvatarLoading" v-model="avatar" />
                </div>
                <q-separator :vertical="$q.screen.xl||$q.screen.lg||$q.screen.md"/>
                <div class="text-center q-pa-md" style="width: 100%">
                  <div class="row q-pt-lg">
                    <div class="col-xs-12 col-sm-12 col-md-6 col-lg-6">
                      <MField
                        label="Nom & Prénom"
                        v-model="form.full_name"
                        :main-design="pageState ==='view'  ? 'borderless' : 'outlined'"
                        :readonly="pageState ==='view'"
                        :hide-bottom-space="pageState ==='view' "
                        validation-rules="required"
                        orientation="vertical"
                        @m-keyup-enter="onFormSubmit"
                      />
                    </div>

                    <div class="col-xs-12 col-sm-12 col-md-6 col-lg-6">
                      <MField
                        label="Identifiant"
                        v-model="form.username"
                        :main-design="pageState ==='view'  ? 'borderless' : 'outlined'"
                        :readonly="pageState ==='view'"
                        :hide-bottom-space="pageState ==='view' "
                        validation-rules="required"
                        orientation="vertical"
                        @m-keyup-enter="onFormSubmit"
                      />
                    </div>

                    <div class="col-xs-12 col-sm-12 col-md-6 col-lg-6">
                      <MField
                        label="Email"
                        v-model="form.email"
                        :main-design="pageState ==='view'  ? 'borderless' : 'outlined'"
                        :readonly="pageState ==='view'"
                        :hide-bottom-space="pageState ==='view' "
                        validation-rules="required|email"
                        orientation="vertical"
                        @m-keyup-enter="onFormSubmit"
                      />
                    </div>

                    <div class="col-xs-12 col-sm-12 col-md-6 col-lg-6">
                      <MField
                        label="Téléphone"
                        v-model="form.phone"
                        :main-design="pageState ==='view'  ? 'borderless' : 'outlined'"
                        :readonly="pageState ==='view'"
                        :hide-bottom-space="pageState ==='view' "
                        validation-rules="required"
                        orientation="vertical"
                        @m-keyup-enter="onFormSubmit"
                      />
                    </div>

                    <div class="col-xs-12 col-sm-12 col-md-6 col-lg-6 text-left" v-if="pageState !== 'create'">
                      <q-toggle
                        :value="!currentItem.disabled_at"
                        :label="!!currentItem.disabled_at ? 'Inactif' : 'Actif'"
                        disable
                        :color="'green'"
                      />
                    </div>

                    <div class="col-6" v-if="pageState === 'create'">
                      <MField
                        label="Mot de passe"
                        v-model="form.password"
                        :main-design="pageState ==='view'  ? 'borderless' : 'outlined'"
                        :readonly="pageState ==='view'"
                        :hide-bottom-space="pageState ==='view'"
                        :type-input="showPassword ? 'text' : 'password'"
                        orientation="vertical"
                        @m-keyup-enter="onFormSubmit"
                      >
                        <template v-slot:mAppend>
                          <q-icon
                            :name="showPassword ? 'la la-eye' : 'la la-eye-slash'"
                            class="cursor-pointer"
                            color="blue-grey-3"
                            @click="showPassword = !showPassword"
                          />
                        </template>
                      </MField>
                    </div>
                  </div>
                </div>
              </q-card-section>
            </q-card>
          </q-form>
        </ValidationObserver>
        <q-tabs  v-if="pageState !== 'create'"
                v-model="tab" active-color="primary"
                align="left"
                class="text-grey"
                indicator-color="primary"
        >
          <q-tab label="Rôles" name="roles" no-caps/>
          <q-tab label="Permissions" name="permissions" no-caps/>
          <q-tab label="Filiales" name="companies" no-caps/>
        </q-tabs>
        <q-separator />
        <q-tab-panels v-model="tab" animated v-if="pageState !== 'create'">
          <q-tab-panel name="roles">
            <div class="row">
              <div class="col-12 q-mt-lg q-pb-md">
                <q-btn
                  class="float-right q-px-sm"
                  color="primary"
                  dense label="Enrégistrer Rôles"
                  stretch :disable="pageState==='view'"
                  @click="onSaveRoles"
                />
              </div>
              <div class="col-12">
                <q-double-draggable
                  :base-list.sync="roles"
                  :target-list.sync="form.roles"
                  :mode="pageState"
                  label-attr="name"
                  name-attr="id"
                  base-title="Tous les roles"
                  target-title="Rôles de l'utilisateur"
                >
                </q-double-draggable>
              </div>
            </div>
          </q-tab-panel>
          <q-tab-panel name="permissions">
            <div class="row">
              <div class="col-12 q-mt-lg q-pb-md">
                <q-btn
                  class="float-right q-px-sm"
                  color="primary"
                  dense label="Enrégistrer Permissions"
                  stretch :disable="pageState==='view'"
                  @click="onSavePermissions"
                />
              </div>
              <div class="col-12">
                <q-double-draggable
                  :base-list.sync="permissions"
                  :target-list.sync="form.permissions"
                  :mode="pageState"
                  label-attr="description"
                  name-attr="id"
                  base-title="Toutes les permissions"
                  target-title="Permissions de l'utilisateur"
                >
                </q-double-draggable>
              </div>
            </div>
          </q-tab-panel>
          <q-tab-panel name="companies">
            <div class="row">
              <div class="col-12 q-mt-lg q-pb-md">
                <q-btn
                  class="float-right q-px-sm"
                  color="primary"
                  dense label="Enrégistrer Filiales"
                  stretch :disable="pageState==='view'"
                  @click="onSaveCompanies"
                />
              </div>
              <div class="col-12">
                <q-double-draggable
                  :base-list.sync="companies"
                  :target-list.sync="form.companies"
                  :mode="pageState"
                  label-attr="name"
                  name-attr="id"
                  base-title="Toutes les filiales"
                  target-title="Filiales de l'utilisateur"
                >
                </q-double-draggable>
              </div>
            </div>
          </q-tab-panel>
        </q-tab-panels>
      </div>

    </template>
  </PageContainer>
</template>

<script>
import PageContainer from "components/PageContainer";
import MControlPanel from "components/MControlPanel";
import {mapActions, mapState} from 'vuex'
import MField from "components/forms/MField";
import MSelect from "components/forms/MSelect";
import MTable from "components/datatables/MTable";
import {ValidationObserver} from 'vee-validate';
import get from 'lodash/get'
import clone from 'lodash/clone'
import pick from 'lodash/pick'
import UserPasswordChangeDialog from "./components/UserPasswordChangeDialog";
import QDoubleDraggable from "components/datatables/QDoubleDraggable";
import AvatarCard from "components/AvatarCard";
import avatar from "src/store/administration/application/avatar";

export default {
  name: "UsersForm",
  components: {
    AvatarCard,
    QDoubleDraggable,
    PageContainer,
    MControlPanel,
    MField,
    MSelect,
    MTable,
    ValidationObserver
  },

  async preFetch({store, currentRoute, previousRoute, redirect, ssrContext}) {
    let id = currentRoute.query.id || currentRoute.params.id
    if (id) await store.dispatch('users/show', {id});
  },

  data() {
    return {
      loading: false,
      isAvatarLoading: false,
      isSelecting: false,
      form: {},
      avatar: null,
      showPassword: false,
      tab: 'roles',
      permissions: [],
      roles: [],
      companies: [],

    }
  },

  methods: {
    onSubmit() {
      this.$q.dialog({
        title: 'Confirmer',
        message: 'Voulez-vous vraiment effectuer cette action ?',
        cancel: true,
        persistent: false,
      }).onOk( async () => {
        this.Loader.show();
         await this.saveAvatar().catch((err) => console.error("Error sauvegader photo", err));
        let payload = this.getPayload()
        await (payload.id ? this.update(payload) : this.create(payload))
        .then((res) => {
          const  msg = payload.id ? 'Mise à jour!' : 'Création réussie';
          this.Motify('success', msg, {name: 'users_form', params: {type: 'view', id: res.id }})
        }).catch((err) =>{
          this.Motify('error', this._getErrorMessage(err))
        }).finally(() => {
          this.Loader.hide()
        })
      })
    },

    async saveAvatar() {
      if (!this.avatar) return null;
      const form = new FormData();
      form.append('file', this.avatar);
      const result = await this.$store.dispatch('resources/upload', form)
      this.form.avatar_id = _.get(result, 'data.id');
      return  result;
    },

    onSaveRoles() {
      this.$q.dialog({
        title: 'Confirmer',
        message: 'Voulez-vous vraiment enrégistrer ces rôles ?',
        cancel: true,
        persistent: true
      }).onOk(async () => {
        if (this.form.id) {
          const roles = this.form.roles.map(x => x.id)
          await this.$store.dispatch('users/attachRoles', {
            id: this.form.id,
            roles
          }).then(async () => {
            await this.$store.dispatch('users/show', {id: this.form.id}).then(async () => {
              await this.Motify('success', `Rôles mise à jour!`,
                {path: `${this.baseUrl}/form/view`, query: {id: this.form.id}}, 2000)
              this.form = _.clone(this.currentItem)
            }).catch((err) => {
              this.Motify('error', this._getErrorMessage(err))
            })
          }).catch(err => {
            this.Motify('error', this._getErrorMessage(err))
          })
        }
      })
    },

    onSavePermissions() {
      this.$q.dialog({
        title: 'Confirmer',
        message: 'Voulez-vous vraiment enrégistrer ces permissions ?',
        cancel: true,
        persistent: true
      }).onOk(async () => {
        if (this.form.id) {
          const permissions = this.form.permissions.map(x => x.id)
          await this.$store.dispatch('users/attachPermissions', {
            id: this.form.id,
            permissions,
          }).then(async (res) => {
            await this.$store.dispatch('users/show', {id: this.form.id}).then(async () => {
              await this.Motify('success', `Permissions mise à jour!`,
                {path: `${this.baseUrl}/form/view`, query: {id: this.form.id}}, 2000)
              this.form = _.clone(this.currentItem)
            }).catch((err) => {
              this.Motify('error', this._getErrorMessage(err))
            })
          }).catch(err => {
            this.Motify('error', this._getErrorMessage(err))
          })
        }
      })
    },

    onSaveCompanies() {
      this.$q.dialog({
        title: 'Confirmer',
        message: 'Voulez-vous vraiment enrégistrer ces filiales ?',
        cancel: true,
        persistent: true
      }).onOk(async () => {
        if (this.form.id) {
          const companies = this.form.companies.map(x => x.id)
          await this.$store.dispatch('users/attachCompanies', {
            id: this.form.id,
            bulk: companies,
          }).then(async () => {
            await this.$store.dispatch('users/show', {id: this.form.id}).then(async () => {
              await this.Motify('success', `Filiales mise à jour!`,
                {path: `${this.baseUrl}/form/view`, query: {id: this.form.id}}, 2000)
              this.form = _.clone(this.currentItem)
            }).catch((err) => {
              this.Motify('error', this._getErrorMessage(err))
            })
          }).catch(err => {
            this.Motify('error', this._getErrorMessage(err))
          })
        }
      })
    },

    onChangeAvatar() {
      if (this.avatar) {
        const reader = new FileReader()
        reader.readAsDataURL(this.avatar)
        reader.onload = (e) => {
          this.form.avatar = e.target.result
        }
      }
    },

    onAvatarButtonClick() {
      this.isSelecting = true
      window.addEventListener('focus', () => {
        this.isSelecting = false
      }, {once: true})
      this.$refs.fileField.$el.click()
    },

    mapPayload() {
      if (this.pageState === 'create') {
        this.resetForm()
      } else if (this.pageState === 'update' || this.pageState === 'view') {
        this.form = clone(this.currentItem)
      }
    },

    getPayload() {
      return this.pageState === 'create' ? this.$helpers.omit(this.form, [ 'avatar']) :
        this.$helpers.omit(this.form, ['password','avatar'])
    },

    resetForm() {
      this.form = clone(this.mForm)
    },

    onChangePassword() {
      this.$q.dialog({
        parent: this,
        component: UserPasswordChangeDialog,
        user: this.currentItem,
        state: 'update',
      }).onOk(() => {
        console.log('Amen!')
      })
    },

    onDeleteRow() {
      this.$q.dialog({
        parent: this,
        cancel: true,
        title:'Suppression',
        message: 'Disponible bientôt!'
      }).onOk(() => {
        console.log('Amen!')
      })
    },

    onDuplicate() {
      this.$q.dialog({
        parent: this,
        message: 'Voulez-vous vraiment dupliquer cet enregistrement?',
        cancel: true,
      }).onOk(() => {
        this.form = clone(this.currentItem)
        this.form.id = null
        this.form.password = null
        return this.$router.replace({path: `${this.baseUrl}/form/create`})
      })
    },

    onChangeUserState() {
      if (this.currentItem) {
        this.$q.dialog({
          title: 'Confirmation',
          message: `Voulez-vous ${!!this.currentItem.disabled_at ? 'activer' : 'désactiver'} ${this.currentItem.full_name} ?`,
          cancel: true,
        }).onOk(async () => {
          await this.$store.dispatch('users/activeOrDisable', {
            id: this.currentItem.id,
            status: !this.currentItem.disabled_at
          }).then(async () => {
            this.Motify('success', 'Fait!')
            await this.$store.dispatch('users/show', {id: get(this.currentItem, 'id')}).then(async () => {
              this.form = clone(this.currentItem)
            })
          }).catch((err) => {
            this.Motify('error', this._getErrorMessage(err))
          })
        })
      }
    },

    onFormSubmit() {
      !this.$refs.FormSubmit.submit()
    },

    onStateButtonClicked() {
      if (this.pageState === 'view') {
        return this.$router.replace({
          name: 'users_form',
          params: {type: 'update', id:  this.$route.params.id},
        })
      } else {
        this.onFormSubmit()
      }
    },

    onActionButtonClicked() {
      if (this.pageState === 'update') {
        this.$router.push({
          name: 'users_form',
          params: {type: 'view', id:  this.$route.params.id},
        })
      } else if (this.pageState === 'create') {
        this.$router.push({name: 'users'})
      } else if (this.pageState === 'view') {
        this.resetForm()
        this.$router.push({
          name: 'users_form',
          params: {type: 'create'},
        })
      }
    },

    async preFetchList() {
      await Promise.all([
        this.$store.dispatch('permissions/index').then(() => {
          this.permissions = _.differenceBy(this.permissionsList, _.get(this.form, 'permissions', []), 'id')
        }),
        this.$store.dispatch('roles/index').then(() => {
          this.roles = _.differenceBy(this.rolesList, _.get(this.form, 'roles', []), 'id')
        }),
        this.$store.dispatch('companies/index').then(() => {
          this.companies = _.differenceBy(this.companiesList, _.get(this.form, 'companies', []), 'id')
        }),
      ])
      // chargement de la photo de profile ce l'utilisateur
      if(this.form.avatar_id){
        this.isAvatarLoading = true;
        this.$store.dispatch('resources/download',this.form.avatar_id)

          .then((file) => this.avatar = file)
           .finally( () => this.isAvatarLoading = false);

      }
    },

    ...mapActions({
      create: 'users/create',
      update: 'users/update',
    }),
  },

  computed: {
    pageState() {
      return this.$route.params.type || this.$route.query.type
    },

    canCreate() {
      return true
    },

    canUpdate() {
      return true
    },

    actions() {
      return [
        /*{
          label: 'Dupliquer cet enregistrement',
          func: this.onDuplicate,
          display: (this.pageState === 'view' && this.form)
        },*/
        {
          label: `${!!(this.currentItem.disabled_at) ? 'Activer' : 'Désactiver'} l'utilisateur`,
          func: this.onChangeUserState,
          display: (this.pageState === 'view' && this.form)
        },
        {
          label: 'Changer le mot de passe',
          func: this.onChangePassword,
          display: (this.pageState === 'view' && this.form)
        },
        {
          label: 'Supprimer l\'utilisateur',
          func: this.onDeleteRow,
          display: (this.pageState === 'view' && this.form)
        },
      ]
    },

    ...mapState({
      baseUrl: state => state.users.baseUrl,
      rolesList: state => _.get(state, 'roles.items.data', []) || [],
      permissionsList: state => _.get(state, 'permissions.items.data', []) || [],
      companiesList: state => _.get(state, 'companies.items.data', []) || [],
      currentItem: state => get(state, 'users.item'),
      mForm: state => get(state, 'users.form'),
    })
  },

  async mounted() {
    this.mapPayload()
    await this.preFetchList()
  },
}
</script>

<style scoped>

</style>
